package com.webproglabs.lab1.lab2;

import com.webproglabs.lab1.lab2.domain.Lab2Interface;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

@Service
public class Lab2Service {
    private final ApplicationContext applicationContext;

    public Lab2Service(ApplicationContext applicationContext) {
        this.applicationContext = applicationContext;
    }

    public Object sum(Object first, Object second, String type) {
        if (type.equals("int")) {
            first = Integer.parseInt(first.toString());
            second = Integer.parseInt(second.toString());
        }
        final Lab2Interface summator =(Lab2Interface)applicationContext.getBean(type);
        return summator.sum(first, second);
    }

    public Object makeItBigger(Object small, String type) {
        if (type.equals("int")) {
            small = Integer.parseInt(small.toString());
        }
        final Lab2Interface biggernator = (Lab2Interface)applicationContext.getBean(type);
        return biggernator.makeItBigger(small);
    }

    public Object reverse (Object value, String type) {
        if (type.equals("int")) {
            value = Integer.parseInt(value.toString());
        }
        final Lab2Interface reversenator = (Lab2Interface) applicationContext.getBean(type);
        return reversenator.reverse(value);
    }

    public Object lenght (Object value, String type) {
        if (type.equals("int")) {
            value = Integer.parseInt(value.toString());
        }
        final Lab2Interface leghtgetter = (Lab2Interface) applicationContext.getBean(type);
        return leghtgetter.lenght(value);
    }
}
