package com.webproglabs.lab1.lab34.controller;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.webproglabs.lab1.lab34.model.Comment;

public class CommentDto {
    private Long id;
    private String text;
    private String authorLogin;

    public CommentDto(Comment comment) {
        this.id = comment.getId();
        this.text = comment.getText();
        this.authorLogin = comment.getOwner().getLogin();
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getId() {
        return id;
    }
    public String getText() {return text;}
    public String getAuthor() {return authorLogin;}
}
