package com.webproglabs.lab1;

import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
class Lab1ApplicationTests {
/*
	private static final Logger log = LoggerFactory.getLogger(Lab1ApplicationTests.class);

	@Autowired
	ProfileService profileService;

	@Autowired
	CommentService commentService;

	@Autowired
	FriendService friendService;

	@Test
	void testUserCreate() {
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		final Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.toString());
		Assertions.assertNotNull(profileService.findUser(user.getId()));
	}

	@Test
	void testUserRead() {
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		final Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.toString());
		final Profile findUser = profileService.findUser(user.getId());
		log.info(findUser.toString());
		Assertions.assertEquals(user, findUser);
	}

	@Test
	void testUserReadNotFound() {
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		Assertions.assertThrows(EntityNotFoundException.class, () -> profileService.findUser(-1L));
	}

	@Test
	void testUserReadAll() {
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		profileService.addUser("Danya", "123", new ArrayList<>());
		profileService.addUser("Vanya", "456", new ArrayList<>());
		final List<Profile> users = profileService.findAllUsers();
		log.info(users.toString());
		Assertions.assertEquals(users.size(), 2);
	}

	@Test
	void testUserReadAllEmpty(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		final List<Profile> users = profileService.findAllUsers();
		log.info(users.toString());
		Assertions.assertEquals(users.size(), 0);
	}

	@Test
	void testCommentCreate(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Comment comment = commentService.addComment("Hello World", user);
		log.info(comment.ToString());
		Assertions.assertEquals(comment.getOwner(), user);
	}

	@Test
	void testCommentRead(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Comment comment = commentService.addComment("Hello World", user);
		log.info(comment.ToString());
		Comment findComment = commentService.findComment(comment.getId());
		log.info(findComment.ToString());
		Assertions.assertEquals(comment, findComment);
	}

	@Test
	void testCommentReadNotFound(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();

		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Comment comment = commentService.addComment("Hello World", user);
		log.info(comment.ToString());
		commentService.deleteAllComments();
		Assertions.assertEquals(commentService.findAllComments().size(), 0);
	}

	@Test
	void testCommentsReadAll(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();
		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Comment comment1 = commentService.addComment("Hello World", user);
		log.info(comment1.ToString());
		Comment comment2 = commentService.addComment("Hello World", user);
		log.info(comment2.ToString());
		Assertions.assertEquals(commentService.findAllComments().size(), 2);
	}

	@Test
	void testUserCommendsRead(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();

		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Comment comment1 = commentService.addComment("Hello World", user);
		log.info(comment1.ToString());
		Comment comment2 = commentService.addComment("Hello World", user);
		log.info(comment2.ToString());
		Assertions.assertEquals(profileService.findUser(user.getId()).getCommentsSize(), 2);
	}

	@Test
	void testDeleteUserComment(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();

		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Comment comment1 = commentService.addComment("Hello World", user);
		log.info(comment1.ToString());
		Comment comment2 = commentService.addComment("Hello World", user);
		log.info(comment2.ToString());
		commentService.deleteComment(comment2.getId());
		Assertions.assertEquals(profileService.findUser(user.getId()).getCommentsSize(), 1);
	}

	@Test
	void testReadProfileFriend(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();

		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Profile friend = profileService.addUser("Friend", "245", new ArrayList<>());
		log.info(friend.ToString());
		friendService.addFriend(user, friend);
		Assertions.assertEquals(user.getFriends().size(), 1);
	}

	@Test
	void testAddProfileFriend(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();

		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Profile friend = profileService.addUser("Friend", "245", new ArrayList<>());
		log.info(friend.ToString());
		friendService.addFriend(user, friend);
		Assertions.assertEquals(friendService.findProfileFriends(user).size(), 1);
	}

	@Test
	void testDeleteProfileFriend(){
		commentService.deleteAllComments();
		profileService.deleteAllUsers();

		Profile user = profileService.addUser("Danya", "123", new ArrayList<>());
		log.info(user.ToString());
		Profile friend = profileService.addUser("Friend", "245", new ArrayList<>());
		log.info(friend.ToString());
		friendService.addFriend(user, friend);
		user = friendService.deleteFriend(user, friend);
		Assertions.assertEquals(friendService.findProfileFriends(user).size(), 0);
	}*/
}
