package com.webproglabs.lab1.lab34.repository;

import com.webproglabs.lab1.lab34.model.Post;
import com.webproglabs.lab1.lab34.model.Profile;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.List;

public interface ProfileRepository extends JpaRepository<Profile, Long> {
    List<Profile> findByLoginLike(String login);
    Profile findOneByLoginIgnoreCase(String login);
}
